/*
prevzato z http://www.rn-wissen.de/index.php/TWI_Slave_mit_avr-gcc

*/
#define F_CPU 8000000
#include <util/twi.h> 	   
#include <avr/interrupt.h>  
#include <stdint.h> 	    
#include "twislave.h"

#include <stdlib.h>         
#include <util/delay.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/sleep.h>



//s-80 0 0 p  tohle poslat po portu


#define SLAVE_ADRESSE 0x52 
static volatile int16_t pwm;
static volatile int8_t imp;
void timer_init()
{
   TCCR0A = 0b00100011;
   TCCR0B = 0b00000001;
   TIMSK0 = 0b00000000;
   
}
ISR(INT0_vect)
{
 if((PIND&0b00001000)==8)  //jestli je pd3 v 1
 {
 imp--;
 }
 else
 {
 imp++;
 }
i2cdata[0]=imp;
}


void ioinit()
{
DDRD=0b01100000;
DDRB=0b00000010;
PORTB=0b00000000;
PORTD=0b00000000;
//nastaveni preruseni na INT0 nastupna hrana
EICRA=0b00000011;
EIMSK=0b00000001;
}
void reguluj()
{
	
	
	
	if(imp>10)
	{
	//PORTB=0b00000010;
	PORTB|=(1<<PB1);
	//PORTD=0b00100000;
	PORTD&=~(1<<PD6);
	pwm=imp*10;
	if(pwm>0xFF)OCR0B=0xFF;
	else OCR0B=imp;
	
	
	}
	else if(imp<(-10))
	{
	//PORTB=0b00000000;
	PORTB&=~(1<<PB1);
	//PORTD=0b01100000;
	PORTD|=(1<<PD6);
	pwm=imp*10;
	if(pwm>0xFF)OCR0B=0xFF;
	
	else OCR0B=-imp;
	}
	else
	{
	PORTB=0b00000000;
	PORTD=0b00000000;
	OCR0B=0;
	}
	
	

}

int main (void)
{


imp=0;
//inicializace IO
ioinit();

//inicializace casovace, rychla PWM, s vystupem na OC0B (PD5-enable pin)
timer_init();

//OCR0B=pwm;
//povoleni preruseni
sei();
//I2C inicializace
init_twi_slave(SLAVE_ADRESSE);

//naplneni buffru
for(uint8_t i=0;i<i2c_buffer_size;i++)
	{
		i2cdata[i]=0;
	}



//nekonecna smycka rizeni
while(1) 
{

			imp=i2cdata[0];
			reguluj();

_delay_ms(20);
} //end.while
} //end.main
